package com.ruoyi.app.domain.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

@Data
@ApiModel(value = "会员+家族成员")
public class AppMemberVo extends BaseEntity {

    @ApiModelProperty(value="家族id")
    private Long familyId;

    @ApiModelProperty(value="会员id")
    private Long userId;

    @ApiModelProperty(value="家族成员id")
    private Long memberId;

    /** 是否已经加入家族 1是 0否 */
    @ApiModelProperty(value="是否已经加入家族 1是 0否")
    @Excel(name = "是否已经加入家族 1是 0否")
    private String joins;

    /** 页面模板id */
    @ApiModelProperty(value="页面模板id")
    @Excel(name = "页面模板id")
    private Long templateId;

    /** 昵称 */
    @ApiModelProperty(value="昵称")
    @Excel(name = "昵称")
    private String nickName;

    /** 头像url */
    @ApiModelProperty(value="头像url")
    @Excel(name = "头像url")
    private String avatar;

    /** 二维码code */
    @ApiModelProperty(value="二维码code")
    @Excel(name = "二维码code")
    private String qrcode;

    /** 手机号码 */
    @ApiModelProperty(value="手机号码")
    @Excel(name = "手机号码")
    private String mobile;

    /** openid */
    @ApiModelProperty(value="openid")
    @Excel(name = "openid")
    private String openid;

    /** verCode */
    @ApiModelProperty(value="verCode")
    @Excel(name = "verCode")
    private String verCode;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value="最后登录时间")
    private Date loginTime;

    @ApiModelProperty(value="登录ip")
    private String loginIp;

    /** 启用  1是 0否 */
    @ApiModelProperty(value="启用  1是 0否")
    @Excel(name = "启用  1是 0否")
    private String enable;

    /** 删除  1是 0否 */
    @ApiModelProperty(value="删除  1是 0否")
    @Excel(name = "删除  1是 0否")
    private String deleted;

    @ApiModelProperty(value="个推客户端id")
    private String clientId;

    /** 接收消息  1是 0否 */
    @ApiModelProperty(value="删除  1是 0否")
    @Excel(name = "接收消息  1是 0否")
    private String receive;


    @ApiModelProperty(value="会员昵称拼音首字母")
    private String userPyCode;
    @ApiModelProperty(value="会员拼音第一个字母")
    private String userPyFirst;

    @ApiModelProperty(value="族员姓名拼音首字母")
    private String MemberPyCode;
    @ApiModelProperty(value="族员拼音第一个字母")
    private String MemberPyFirst;

    @ApiModelProperty(value="父辈")
    private String father;

    /** 配偶 */
    @ApiModelProperty(value="配偶 会员id")
    @Excel(name = "配偶")
    private Long spouseUserId;
    /** 配偶 */
    @ApiModelProperty(value="配偶")
    @Excel(name = "配偶")
    private String spouse;

    /** 姓名 */
    @ApiModelProperty(value="姓名")
    @Excel(name = "姓名")
    private String name;

    /** 生日 */
    @ApiModelProperty(value="生日")
    @Excel(name = "生日" , width = 30, dateFormat = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date birthday;

    /** 性别：1-男，2-女，0-未知（字典） */
    @ApiModelProperty(value="性别 1-男，2-女，0-未知")
    @Excel(name = "性别" , readConverterExp = "字=典")
    private String gender;

    /** 文化程度（字典） */
    @ApiModelProperty(value="文化程度")
    @Excel(name = "文化程度" , readConverterExp = "字=典")
    private String education;

    /** 状态：1读书、2工作、3退休、4过世 */
    @ApiModelProperty(value="态：1读书、2工作、3退休、4过世")
    @Excel(name = "状态：1读书、2工作、3退休、4过世")
    private String state;

    @ApiModelProperty(value="母亲")
    private String motherName;
    @ApiModelProperty(value="父亲")
    private String parentName;
    @ApiModelProperty(value="父亲id")
    private Long parentId;
    @ApiModelProperty(value="申请状态 1申请 2同意 3拒绝")
    private String status;


    private Long memberCreateBy;
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date memberCreateTime;
    private Long memberUpdateBy;
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date memberUpdateTime;
    private String memberRemark;

    private Long userCreateBy;
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date userCreateTime;
    private Long userUpdateBy;
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date userUpdateTime;
    private String userRemark;

    @ApiModelProperty(value="是否管理员 Y是 N否")
    private String admin;

    @ApiModelProperty(value="是否族长  Y是  N否")
    private String patriarch;

    @ApiModelProperty(value="第几代")
    private Integer generation;
}
